import numpy as np

from processing.enums import FrequencyScale, StftWindowType, AdiImpl


APP_NAME = "SoundScapeExplorer"

STATE_PRESENT = "✅"
STATE_MISSING = "❌"
STATE_UNDEFINED = "⚪"

MDM_EMPTY = np.stack([[]])
STRING_DELIMITER = "|||"
LABEL_PREFIX = "LABEL_"
AUTOCLUSTER_PREFIX = "AUTOCLUSTER_"
EPSILON_32 = np.finfo(np.float32).eps

BIRDNET_WINDOW_MS = 3000
PERCH_WINDOW_MS = 5000
SURFPERCH_WINDOW_MS = 5000
VGGISH_WINDOW_MS = 1000
YAMNET_WINDOW_MS = 1000
MUSICCLASS_WINDOW_MS = 3000

WINDOW_MS = 1000
HOP_MS = 1000

FREQUENCY_SCALE: FrequencyScale = FrequencyScale.LIN

SPECTRO_N_BANDS = 64
SPECTRO_SCALE: FrequencyScale = FrequencyScale.LIN
SPECTRO_STFT_WINDOW_TYPE: StftWindowType = StftWindowType.HANN
SPECTRO_STFT_WINDOW_MS = None
SPECTRO_STFT_OVERLAP_RATIO = 0.0
SPECTRO_DBFS_REF = 1.0

MPS_N_BANDS = 64
MPS_SCALE: FrequencyScale = FrequencyScale.LIN
MPS_STFT_1_WINDOW_MS = 20
MPS_STFT_1_OVERLAP_RATIO = 0.95
MPS_STFT_2_WINDOW_MS = 100
MPS_STFT_2_OVERLAP_RATIO = 0.167

MFCC_N_MFCC = 13

NDSI_BAND_BIO = (1000, 10000)
NDSI_BAND_ANTHRO = (0, 1000)

ADI_BIN_STEP = 500
ADI_DB_THRESHOLD = -50
ADI_IMPL: AdiImpl = AdiImpl.SHANNON

HT_FRAME_SIZE = 512
MED_FRAME_SIZE = 512

LEQ_SHORT_DT = 0.05  # seconds (20 Hz)

LEQ_PERCENTILE_VALUE = 90

LEQ_DIFF_PERCENTILE_A = 90
LEQ_DIFF_PERCENTILE_B = 10

UMAP_MIN_DIST = 0.1
